#include <stdio.h>
#include <mpi.h>
#include <string.h>

#define SIZE 100000
/* #define SIZE 10000 */

main(int argc, char* argv) {

int rank;   /* rank of process */
int p;      /* number of process */
int tag=0;  /* tag for messages  */
MPI_Status status;  /* return status for receive */

MPI_Request s_req;
MPI_Request r_req;

MPI_Request s_req2;
MPI_Request r_req2;

int source;
float msg[SIZE];
double start,finish,time;

/* Start up MPI */
MPI_Init(&argc, &argv);

/* Find out process rank */
MPI_Comm_rank(MPI_COMM_WORLD, &rank);

/* Find out number of prosess */
MPI_Comm_size(MPI_COMM_WORLD, &p);

printf("Time\n");
fflush(stdout);
start = MPI_Wtime();

    if(rank == 0) {
       for (source=1;source<p;source++){
           MPI_Isend(msg,SIZE,MPI_FLOAT,source,tag,MPI_COMM_WORLD,&s_req);
           MPI_Wait(&s_req,&status);
       } /* end of for source */
    } /* end of if rank */
    else {
      MPI_Irecv(msg,SIZE,MPI_FLOAT,source,tag,MPI_COMM_WORLD,&r_req);
      MPI_Wait(&r_req,&status);
    } /* end of if else */

    if (rank == 0){
       for (source=1;source<p;source++){
          MPI_Irecv(msg,SIZE,MPI_FLOAT,source,tag,MPI_COMM_WORLD,&r_req2);
          MPI_Wait(&r_req2,&status);  
       } /* for */
    } /* if */
    else{
       MPI_Isend(msg,SIZE,MPI_FLOAT,0,tag,MPI_COMM_WORLD,&s_req2); 
       MPI_Wait(&s_req2,&status);   

    } /* else */
finish = MPI_Wtime();
time = finish - start;

printf("rank: %d time: %f\n",rank,time/200.0);
fflush(stdout);
      
/* Shut down MPI */
MPI_Finalize();
exit(0);
} /* end of main */